-- Test translate_service
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'translate_service', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_service', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_service', array['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate service cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into service (service_id, company_id, icon_name, name, description)
values (5, 1, 'information', 'Service A', '<p>A</p>')
     , (6, 1, 'toilet', 'Service B', '<p>B</p>')
;

insert into service_i18n (service_id, lang_tag, name, description)
values (6, 'ca', 'serveib', '<p>B</p>')
;

select lives_ok(
	$$ select translate_service(5, 'ca', 'Servei A', '<p>a</p>') $$,
	'Should be able to translate the first service'
);

select lives_ok(
	$$ select translate_service(6, 'es', 'Servicio B', '<p>b</p>') $$,
	'Should be able to translate the second service'
);

select lives_ok(
	$$ select translate_service(6, 'ca', 'Servei B', null) $$,
	'Should be able to overwrite the catalan translation of the second service, with no description'
);

select bag_eq(
	$$ select service_id, lang_tag, name, description::text from service_i18n $$,
	$$ values (5, 'ca', 'Servei A', '<p>a</p>')
	        , (6, 'ca', 'Servei B', '')
	        , (6, 'es', 'Servicio B', '<p>b</p>')
	$$,
	'Should have added and updated all translations.'
);


select *
from finish();

rollback;
